local classTable = {};
local indexTable = { "DEATH KNIGHT", "DRUID", "HUNTER", "MAGE", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR" }; 
local rDK = nil;
local rDruid = {};
local rHunter = nil;
local rMage = { 17020, 17031, 17032 };
local rPali = { 17033, 21177 };
local rPriest = {};
local rRogue = nil;
local rShaman = { 17030 };
local rWarlock = { 5565, 16583 };
local rWarrior = nil;
local reagents = { rDK, rDruid, rHunter, rMage, rPali, rPriest, rRogue, rShaman, rWarlock, rWarrior };

function AutoBuyReagents_OnLoad()
	SLASH_AUTOBUYREAGENTS1   = "/autobuyreagents";
	SLASH_AUTOBUYREAGENTS2 = "/abr";
	SlashCmdList["AUTOBUYREAGENTS"] = function(msg)
		AutoBuyReagents_SlashCommandHandler(msg);
	end
		
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("MERCHANT_SHOW");
	this:RegisterEvent("PLAYER_LOGIN");
		--this:RegisterEvent("MERCHANT_UPDATE");
end


function AutoBuyReagents_OnEvent()
	if( event == "ADDON_LOADED" and arg1== "AutoBuyReagents" ) then
		if( reagentTable == nil ) then
			reagentTable = {-1,-1,-1};
		end
		
		AutoBuyReagents_Out("Auto Buy Reagents loaded. Use /autobuyreagents or /abr to access the setup screen.");
	end
	
	if( event == "PLAYER_LOGIN" ) then
		AutoBuyReagents_DruidReagents();
		AutoBuyReagents_PriestReagents();
		
		classTable = AutoBuyReagents_FindTable( AutoBuyReagents_FindClass() );
	end
	
	if( event == "MERCHANT_SHOW" ) then
		if( AutoBuyReagents_DoesMerchantHaveReagents() ) then
			AutoBuyReagents_GetCurrentReagents();
			
			AutoBuyReagents_BuyReagents();
		end
	end
end


function AutoBuyReagents_SlashCommandHandler( msg )
	local frame = getglobal( "AutoBuyReagentsFrame" );
	
	if( msg == "" ) then
		AutoBuyReagents_HideFrame( frame );
	end	
end


function AutoBuyReagents_LoadPresets()
	if( classTable ~= nil ) then
		local numReagents = getn(classTable);
		
		for i = 1, getn(classTable) do
			local textBox = getglobal( "ReagentFont" .. i );
			local editBox = getglobal( "ReagentNumBox" .. i );
			local checkBox = getglobal( "ReagentCheckButton" .. i );


			textBox:SetText( AutoBuyReagents_GetItemName( classTable[i]) );
			
			if( reagentTable[i] == -1 ) then
				editBox:SetText( 0 )
			else
				editBox:SetText( reagentTable[i] );
			end
			
			if( reagentTable[i] == -1 ) then
				checkBox:SetChecked( false );
			end
				
		end
		
		AutoBuyReagents_resetBoxes(numReagents);
		
	else
		AutoBuyReagents_Out("Your class has no reagents.");
	end
end


function AutoBuyReagents_resetBoxes( num )
	local checkBox, inputBox;
	
	for i = 1, num do
		checkBox = getglobal( "ReagentCheckButton" .. i );
		inputBox = getglobal( "ReagentNumBox" .. i );
		checkBox:Show();
		inputBox:Show();
	end
				
	for i = num+1, 3 do
		checkBox = getglobal( "ReagentCheckButton" .. i );
		inputBox = getglobal( "ReagentNumBox" .. i );
		checkBox:Hide();
		inputBox:Hide();
	end
	
end




function AutoBuyReagents_Out(text)
	DEFAULT_CHAT_FRAME:AddMessage(text);
end


function AutoBuyReagents_DruidReagents()
	local rank1 =  ({ GetSpellInfo( "Rebirth" )})[2];
	local rank2 = ({ GetSpellInfo( "Gift of the Wild" )})[2];
	local lvl = UnitLevel("player");
	
	if( AutoBuyReagents_FindClass() == "DRUID" ) then
		if( lvl >= 20 and rank1 ~= nil ) then
			if( rank1 == "Rank 1" ) then rDruid[1] = 17034;
			elseif( rank1 == "Rank 2" ) then rDruid[1] = 17035;
			elseif( rank1 == "Rank 3" ) then rDruid[1]= 17036;
			elseif( rank1 == "Rank 4"  ) then rDruid[1] = 17037;
			elseif( rank1 == "Rank 5"  ) then rDruid[1] = 17038;
			elseif( rank1 == "Rank 6"  ) then rDruid[1]= 22147;
			elseif( rank1 == "Rank 7" ) then rDruid[1] = 44614;
			end
		end
	
		if( lvl >= 50 and rank2 ~= nil ) then 				
			if( rank2 == "Rank 1" ) then rDruid[2] = 17021;
			elseif( rank2 == "Rank 2" ) then rDruid[2]= 17026;
			elseif( rank2 == "Rank 3" ) then rDruid[2] = 22148;
			elseif( rank2 == "Rank 4" ) then rDruid[2] = 44605;
			end
		end
	end
end


function AutoBuyReagents_PriestReagents()
	local iterator = 1;
	local rank1 = ({ GetSpellInfo( "Prayer of Fortitude" )})[2];
	local rank2 = ({ GetSpellInfo( "Prayer of Spirit")})[2];
	local rank3 = ({ GetSpellInfo( "Prayer of Shadow Protection")})[2];
		
	if( AutoBuyReagents_FindClass() == "PRIEST" ) then
		if( rank1 ~= nil ) then
			if( rank1 == "Rank 1") then
				rPriest[iterator] = 17028;
			elseif( rank1 == "Rank 2" or rank1 == "Rank 3") then
				rPriest[iterator] = 17029;
			elseif( rank1 == "Rank 4") then
				rPriest[iterator] = 44615;
			end
			
			iterator = iterator + 1;
		end
		
		if( rank2 ~= nil ) then
			if( rank2 == "Rank 1" or rank2 == "Rank 2" ) then
				if( rank1 == nil ) then
					rPriest[iterator] = 17029;
				elseif( rank1 ~= "Rank 2" or rank1 ~= "Rank 3") then
					rPriest[iterator] = 17029;
				end
			end
			
			if( rank2 == "Rank 3" ) then
				if( rank1 == nil ) then
					rPriest[iterator] = 44615;
				elseif( rank1 ~= "Rank 4" ) then
					rPriest[iterator] = 44615;
				end
			end
			
			iterator = iterator + 1;
		end
		
		if( rank3 ~= nil ) then
			if( rank3 == "Rank 1" or rank3 == "Rank 2" ) then
				if( rank1 == nil and (rank2 ~= "Rank 1" or rank2 ~= "Rank 2" )) then
					rPriest[iterator] = 17029;
				elseif( rank1 ~= "Rank 2" or rank1 ~= "Rank 3") then
					rPriest[iterator] = 17029;
				end
			end
			
			if( rank3 == "Rank 3" ) then
				if( rank1 == nil and rank2 ~= "Rank 3" ) then
					rPriest[iterator] = 44615;
				elseif( rank1 ~= "Rank 4" and rank2 ~= "Rank 4") then
					rPriest[iterator] = 44615;
				end
			end
		end
	end
end


function AutoBuyReagents_HideFrame( frame )
	if( frame:IsVisible()) then				
		frame:Hide();
	else
		frame:Show();
	end
end


function AutoBuyReagents_FindTable( class )
	local tbl = 0;
	
	for i = 1, # indexTable do
		if( class == indexTable[i] ) then
			tbl = i;
		end
	end
	
	if( tbl == 0 ) then
		AutoBuyReagents_Out( "Cannot Determine Class Error") ;
		return nil;
	else
		return reagents[tbl];
	end
end


function AutoBuyReagents_FindClass()
	return ({UnitClass("player")})[2];
end




function AutoBuyReagents_GetItemName( var )
	item =  {GetItemInfo( var )};
	return item[1];
end


function AutoBuyReagents_SaveButtonPressed()
	local Paliflag = false;


	if( AutoBuyReagents_FindClass() == "PALADIN" ) then
		Paliflag = true;
	end
	
	if( Paliflag ) then
		for i = 1, # classTable do
			local checkBox = getglobal( "ReagentCheckButton" .. i );
			local textBox = getglobal( "ReagentNumBox" .. i );
			local num = textBox:GetText();
			local modBy = 0;
			
			if( checkBox:GetChecked() ) then
				if( classTable[i] == 21177 ) then
					modBy = 20;
					
					if( mod(num,modBy) == 0 ) then
						reagentTable[i] = textBox:GetText();
					else
						textBox:SetText( reagentTable[i] .. "" );					
						message( "ABR: " .. AutoBuyReagents_GetItemName( classTable[i] ) .. " can only be bought in stacks of 20. Make all divisible by 20 (20, 40, etc.)");
					end
				else
					reagentTable[i] = textBox:GetText();
				end
			end
		end
	else  
		reagentTable[1] = ReagentNumBox1:GetText();
		reagentTable[2] = ReagentNumBox2:GetText();
		reagentTable[3] = ReagentNumBox3:GetText();
	end
end


--num refers to the index of the classTable
function AutoBuyReagents_GetCurrentReagents()
	numReagentsTable = {};


	if classTable ~= nil then
		for i = 1, # classTable do
			numReagentsTable[i] = 0;
		
			for bag = 4, 0, -1 do
				local size = GetContainerNumSlots(bag);
				
				if (size > 0) then
					for slot = 1, size, 1 do					
						if( GetContainerItemLink(bag, slot) ~= nil ) then
							local itemName = AutoBuyReagents_GetItemName( GetContainerItemLink(bag, slot) );
							local reagentName = AutoBuyReagents_GetItemName( classTable[i] );
							local _,itemCount = GetContainerItemInfo(bag, slot);
							
							if( itemName == reagentName ) then
								numReagentsTable[i] = numReagentsTable[i] + itemCount;
							end
						end
					end
				end
			end
		end
	end
end


function AutoBuyReagents_DoesMerchantHaveReagents()
	local booleanReagentsTable = {false, false, false};
	merchantIndexes = {};
	
	for i = 1, # classTable do
		for index = 0, GetMerchantNumItems() do
			local itemName = GetMerchantItemInfo( index );
			local reagentName = AutoBuyReagents_GetItemName( classTable[i] );
			
			if( itemName == reagentName ) then
				booleanReagentsTable[i] = true;
				merchantIndexes[i] = index;
			end
		end
	end
	
	return (booleanReagentsTable[1] or booleanReagentsTable[2] or booleanReagentsTable[3]);
end




function AutoBuyReagents_BuyReagents()


	for i = 1, # classTable do
		if( numReagentsTable[i] < tonumber(reagentTable[i]) ) then
			local checkBox = getglobal( "ReagentCheckButton" .. i );
			local numBuy = tonumber(reagentTable[i]) - numReagentsTable[i];
			
			if( checkBox:GetChecked() ) then
				AutoBuyReagents_Out( "ABR attempt to buy " .. numBuy .. " of " .. AutoBuyReagents_GetItemName( classTable[i] )  .. ". May have some missing of the max amount if Paladin.");
				local maxBuy = 0;
				local countBy = 0;
					
				if( classTable[i] == 21177 ) then
					maxBuy = 1;
					countBy = 20;
				elseif( classTable[i] == 17033 ) then
					maxBuy = 5;
					countBy = 5;
				else
					maxBuy = 20;
					countBy = 20;
				end					
					
				while( numBuy >= countBy ) do
					BuyMerchantItem( merchantIndexes[i], maxBuy );
				 	numBuy = numBuy - countBy;
				end					
				
				if( numBuy < maxBuy and numBuy > 0 ) then
		 			BuyMerchantItem( merchantIndexes[i], numBuy );
		 		end
	 		end
		end
	end
end
